# This file was created automatically by SWIG.
import ionc
from ooflib.SWIG.engine.properties import PropertyPtr
class IonDiffusionPtr(PropertyPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C IonDiffusion instance at %s>" % (self.this,)
class IonDiffusion(IonDiffusionPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(ionc.new_IonDiffusion,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: ion.spy,v $
# $Revision: 1.3 $
# $Author: reida $
# $Date: 2012-03-28 19:16:01 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@nist.gov.


# Very similar to the non-charged diffusion, but with Charge_Flux
# instead of Atom_Flux, and Voltage instead of Concentration.  Also,
# there is no "mobility" analog, and no surface property (yet?).

from ooflib.common import runtimeflags

from ooflib.common import utils
from ooflib.common.IO import parameter
from ooflib.engine import problem
from ooflib.engine import propertyregistration
from ooflib.SWIG.engine import symmmatrix

from ooflib.engine.IO import interfaceparameters

from ooflib.EXTENSIONS.diffusion import diff_problem


PropertyRegistration = propertyregistration.PropertyRegistration

# Only one kind, symmetry is inherited from Diffusion property.

reg = PropertyRegistration(
    'Couplings:IonDiffusion',
    IonDiffusion,
    "ooflib.SWIG.EXTENSIONS.diffusion.ion",
    ordering=113,
    params=[parameter.FloatParameter('z',
                                     1.0, tip=parameter.emptyTipString)],
    propertyType="IonDiffusion",
    tip="Diffusion of charged species."
    )

reg.fluxInfo(fluxes=[diff_problem.Charge_Flux, diff_problem.Atom_Flux],
             fields=[problem.Voltage, diff_problem.Concentration],
             nonlinear=True,time_derivs=[0])


